function Corr = compute_correlation_2d(Theo,Expe)
%% Compute the 2d correlation between two 2d images with respect to 
% horizontal and vertical shifts


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if size(Theo,1)==1 || size(Theo,2)==1 || size(Expe,1)==1 || size(Expe,2)==1
    error('compute_correlation_2d: one of the input is 1d instead of 2d');
end
MagT = norm(Theo(:));
MagE = norm(Expe(:));

Corr = max(max(abs(xcorr2(Theo, Expe)))) / (MagT*MagE);

