function idx = detect_peaks(x) 
% Peak detection

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Reprage des Maximum
x = x(:);
% identifie si le signal est descendant ou montant
upordown = sign(diff(x));
% Trouve les points o le signal est montant avant et descendant aprs
maxflags = [upordown(1)<0; diff(upordown)<0; upordown(end)>0];
maxima   = find(maxflags);

% Elimination des pics parasites en dessous d'un certain seuil
y1 = 20*log10(x);
y2 = medfilt1(20*log10(x), 75);
Diff = y1(maxima) - y2(maxima);
seuil = 2;
indDiff = Diff > seuil;
idx = maxima(indDiff);

test = diff(idx);
for ii = 1 : length( find(test<20) )
ind = find(test<20, 1, 'first');
vect = [x(idx(ind)) ; x(idx(ind+1))];
indm = find(vect == min(vect));
test(ind) = [];
idx(ind + indm - 1) = [];
end
