function image = inpaint_ODS(image, sup)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[M N] = size(image);

G1 = eye(M*N);
G1(1:end-1,2:end) = G1(1:end-1,2:end) - eye(M*N-1);
G1(M:M:end,:) = [];

G2 = eye(M*N);
G2(end-M+1:end,:)=0;
G2(1:end-M,(M+1):end) = G2(1:end-M,(M+1):end) - eye((M*(N-1)));
G2(end-M+1:end,:) = [];

G = [G1 ; G2];

image = image(:);
sup = sup(:);

X = image(sup);

Gr = G(:,~sup);
Gs = G(:,sup);


rec = pcg(Gr'*Gr, -Gr'*Gs*X);

image(~sup) = rec;

image = reshape(image, M, N);

end