function ima2= median_filter_2d(ima)

%% warning : ima must be a tall matrix (nbrows < nbcolumns)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ima = ima.';

[m,n]=size(ima);
ima(1,:) = medfilt1(ima(1,:),3);
ima(m,:) = medfilt1(ima(m,:),3);
ima(:,1) = medfilt1(ima(:,1),3);
ima(:,n) = medfilt1(ima(:,n),3);
ima2=zeros(size(ima));
ima2(1,:) = ima(1,:);
ima2(m,:) = ima(m,:);
ima2(:,1) = ima(:,1);
ima2(:,n) = ima(:,n);
mm=[1 1 1 1 1 1 1 1 1];
for i = 2 : m - 1
    for j = 2 : n - 1              
        for k = 1 : 3
            for l = 1 : 3
                    mm(k+3*(l-1))=ima(i+k-2,j+l-2); 
            end
        end
        pp = sum(sum(mm))/9;
        ima2(i,j)=pp;
    end
end
ima2(1,1) = (ima2(1,1)+ima2(1,2)+ima2(2,1)+ima2(2,2))/4;
ima2(m,n) = (ima2(m,m)+ima2(m,n-1)+ima2(m-1,n)+ima2(m-1,n-1))/4;
ima2(1,n) = (ima2(1,n)+ima2(1,n-1)+ima2(2,n)+ima2(2,n-1))/4;
ima2(m,1) = (ima2(m,1)+ima2(1,2)+ima2(m-1,1)+ima2(m-1,2))/4;

ima2 = ima2.';

