function plot_ODS(ODSToPlot,Correlations,DisplayMask)

% function that display the real amplitude of the ODS
% INPUT PARAMETERS
% Nx,Ny = size of the plate
% ODSToPlot = cell matrix

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[NbFigureColumns,NbFigureRows] = size(ODSToPlot);

load('colormap_thermal.mat')
colormap(map_thermal)

for ii=1:NbFigureRows
    for jj=1:NbFigureColumns
        subplot(NbFigureRows,NbFigureColumns,(ii-1)*NbFigureColumns+jj);
        IMAG = Cpx2Surf(ODSToPlot{jj,ii},ODSToPlot{1,ii});
        % if DisplayMask contains NaN, add mask for cleaner display  
        if ~isempty(find(isnan(DisplayMask),1))
            IMAG = add_blackframe(IMAG.* DisplayMask,2);
        end
        imagesc(IMAG); 
        if Correlations(jj,ii)~=1
            xlabel(['C=',num2str(round(100*Correlations(jj,ii))),'%']);
        end
    end
end

