function SelectedFreqIdx = select_frequencies_adhoc(SpectraVibro,SPECP)
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Compute the spatial energy of the spectrum at each frequency
EnergyPerFreq = zeros(SPECP.NbFreqs,1);
for kk = 1 : SPECP.NbFreqs
    EnergyPerFreq(kk) = norm(SpectraVibro(:,kk));
end

% Detect peaks
SelectedFreqIdx = detect_peaks(EnergyPerFreq);

% Deletion of frequencies with too much noise
% currently: manually selected
FalseMode = [1 6 8 10 17 25 30 31 35 36 38 39 41 46 47];
SelectedFreqIdx(FalseMode) = [];
SelectedFreqIdx(end-1) = [];
end