function [SpectraVibroD,VibroDANTP] = zero_pad(SpectraVibroD,VibroDANTP)

% add measurements where mask = 0 and no measurement is available to fit a
% rectangular structure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                        
% Nearfield ACoustic HOlography with Sparse regularization (NACHOS)
% Version 1.0                                    
%     
% Copyright 2012 Antoine Peillot, Franois Ollivier, Gilles Chardon, 
%                Laurent Daudet, Nancy Bertin, Rmi Gribonval
% 
% For all details please refer to README.TXT
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% build mask coordinates
[~,indxmin] = min(VibroDANTP.XYPos(:,1));
[~,indxmax] = max(VibroDANTP.XYPos(:,1));
[~,indymin] = min(VibroDANTP.XYPos(:,2));
[~,indymax] = max(VibroDANTP.XYPos(:,2));

oindymin = min(indymin,indymax);
oindymax = max(indymin,indymax);

XPos = unique(VibroDANTP.XYPos(indxmin:indxmax,1));
YPos = unique(VibroDANTP.XYPos(oindymin:oindymax,2));

% add zeros
[Ix,Iy] = find(~VibroDANTP.Mask);

NbZeros = length(Ix);
SpectraVibroD = [SpectraVibroD;zeros(NbZeros,size(SpectraVibroD,2))];
temp = [XPos(Ix),YPos(Iy)];
VibroDANTP.XYPos = [VibroDANTP.XYPos; temp];
    



